#
# Schema for components
# 

drop table component;
create table component
  (
    component_id int not null primary key auto_increment,
    component_type_id int not null,
    serial_num varchar(24),
    verif tinyint(1),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;
    

drop table component_rel;
create table component_rel
  (
    component_rel_id int not null primary key auto_increment,
    parent_component_id int,
    child_component_id int,
    logical_order int,
    logical_desc varchar(24),
    component_rel_type_id int,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

# note - spares location could be new "spare" relationship (to a room, for example)
drop table component_type;
create table component_type
  (
    component_type_id int not null primary key auto_increment,
    component_type_name varchar(60),
    description varchar(100),
    form_factor_id int,
    mfg_id int,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table mfg;
create table mfg
  (
    mfg_id int not null primary key auto_increment,
    mfg_name varchar(100)
  ) type=InnoDb;

drop table form_factor;
create table form_factor
  (
    form_factor_id int not null primary key auto_increment,
    form_factor varchar(100)
  ) type=InnoDb;

drop table component_type_cog_person;
create table component_type_cog_person
  (
    component_type_cog_person_id int not null primary key auto_increment,
    component_type_id int,
    person_id int,
    role_name_id int
  ) type=InnoDb;

drop table component_type_document;
create table component_type_document
  (
    component_type_document_id int not null primary key auto_increment,
    component_type_id int,
    uri_id int
  ) type=InnoDb;

drop table component_type_status;
create table component_type_status
  (
    component_type_status_id int not null primary key auto_increment,
    component_type_id int,
    spare_qty int,
    stock_qty int
  ) type=InnoDb;

drop table component_type_function;
create table component_type_function
  (
    component_type_function_id int not null primary key auto_increment,
    component_type_id int,
    function_id int
  ) type=InnoDb;

drop table function;
create table function
  (
    function_id int not null primary key auto_increment,
    function varchar(100) 
  ) type=InnoDb;

drop table component_type_if;
create table component_type_if
  (
    component_type_if_id int not null primary key auto_increment,
    component_type_id int,
    required tinyint(1),
    presented tinyint(1),
    component_rel_type_id int,
    component_type_if_type_id int
  ) type=InnoDb;

drop table component_type_if_type;
create table component_type_if_type
  (
    component_type_if_type_id int not null primary key auto_increment,
    if_type varchar(100)
  ) type=InnoDb;

drop table component_port;
create table component_port
  (
    component_port_id int not null primary key auto_increment,
    component_port_type_id int,
    component_id int,
    component_port_name varchar(40),
    virtual tinyint(1),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table component_port_type;
create table component_port_type
  (
    component_port_type_id int not null primary key auto_increment,
    component_port_type varchar(60),
    component_port_group varchar(60),
    component_port_pin_count int,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table port_pin;
create table port_pin
  (
    port_pin_id int not null primary key auto_increment,
    port_pin_type_id int,
    port_pin_name varchar(60),
    port_pin_io_addr varchar(60),
    component_port_id int,
    port_pin_designator_id int,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table port_pin_type;
create table port_pin_type
  (
    port_pin_type_id int not null primary key auto_increment,
    port_pin_type varchar(12)
  ) type=InnoDb;

drop table port_pin_designator;
create table port_pin_designator
  (
    port_pin_designator_id int not null primary key auto_increment,
    component_port_type_id int,
    designator_order int,
    designator varchar(60) 
  ) type=InnoDb;

drop table conductor;
create table conductor
  (
    conductor_id int not null primary key auto_increment,
    cable_id int,
    port_pin_a_id int,
    port_pin_b_id int,
    signal_name varchar(60),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table cable;
create table cable
  (
    cable_id int not null primary key auto_increment,
    color varchar(40),
    label varchar(40)
  ) type=InnoDb;


# component type template tables

drop table component_port_template;
create table component_port_template
  (
    component_port_template_id int not null primary key auto_increment,
    component_type_id int,
    component_port_type_id int,
    component_port_name varchar(40), 
    component_port_order int,
    virtual tinyint(1),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table port_pin_template;
create table port_pin_template
  (
    port_pin_template_id int not null primary key auto_increment,
    component_port_template_id int,
    port_pin_type_id int,
    port_pin_designator_id int,
    port_pin_name varchar(60),
    port_pin_io_addr varchar(60),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;





