# Tables used by more than one sub-schema defined here.

# Uri table stores references to files on the file system.
#
# Columns:
#   uri - contains file system path encoded as uri
#           (ie. file://host/path/to/file.txt )
#   uri_modified_date - the mtime attribute of the file
#   modified_date - time of row insert
#   modified_by - username or app name who performed insert

drop table uri;
create table uri
  (
    uri_id int not null primary key auto_increment,
    uri varchar(255),
    uri_modified_date timestamp,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table person;
create table person
  (
    person_id int not null primary key auto_increment,
    first_nm varchar(30),
    middle_nm varchar(30),
    last_nm varchar(30),
    userid varchar(30)
  ) type=InnoDb;

drop table role;
create table role
  (
    role_id int not null primary key auto_increment,
    person_id int,
    role_name_id int
  ) type=InnoDb;

drop table role_name;
create table role_name
  (
    role_name_id int not null primary key,
    role_name varchar(30)
  ) type=InnoDb;

insert into role_name values (1, "admin");

