-- Tables used by more than one sub-schema defined here.

-- Uri table stores references to files on the file system.
--
-- Columns:
--   uri - contains file system path encoded as uri
--           (ie. file://host/path/to/file.txt )
--   uri_modified_date - the mtime attribute of the file
--   modified_date - time of row insert
--   modified_by - username or app name who performed insert

drop table uri cascade constraints;
create table uri
  (
    uri_id int not null primary key,
    uri varchar(255),
    uri_modified_date timestamp,
    modified_date timestamp,
    modified_by varchar(10)
  );

drop sequence seq_uri;
create sequence seq_uri;
