package ALHCrawlerParser;

# This package provides routines for parsing alh config files for alh_crawler
#

use FileHandle;
use File::Basename;
use Cwd;

use LogUtil;

require Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(&parse_alhfile);
our @EXPORT_OK = qw();
our $VERSION = 1.00;

######################################
# parse alh config files files keeping
# pv references for DB update
# Public
######################################
sub parse_alhfile {
    my ($seen_ref,$alh_hits_ref,$file) = @_;
    my $name;
    my ($pvname,$id,$parent);
    my $alhModTime = 0;
    my $currentDir;

    #log('debug',"parse_alhfile: file=$file ");

    if ( $seen_ref->{$file} ) { return; }

    if (!open(IN, $file) ) {
        log('error', "APSAlhScan: Can't open $file: $!");
        return;
    }

    $seen_ref->{$file}=1;

    my @pv_list = ();

    while (my $alhLine = <IN>) {
      
        $alhLine =~ s/^\s+//;  # Remove leading whitespace
        # Look for lines  CHANNEL parentName ChannelName <mask> 
        if( $alhLine =~ m/^CHANNEL/) {
            ($id,$parent,$pvname) = split (/\s+/,$alhLine);

            if ( $pvname =~ /\$\(/ || $pvname =~ /\$\{/ ) {   #### )}
                log('error',"Macro present in CHANNEL $pvname.");
            } else {
                push (@pv_list,[$pvname]);
                #log('debug', "APSAlhScan: pushing pvname=$pvname");
            }
        }
    }
    push (@$alh_hits_ref,[$file,\@pv_list]);
    $count=scalar(@pv_list);
    log('info', "APSAlhScan: $file  pv_count=$count");
    close (IN);
}

1;


