/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence;

import java.io.Serializable;

/**
 * Base class for all IRMIS data objects that are backed by a relational data store.
 */
public class IRMISDataObject implements Serializable {

    private Long id;

    /**
     * Get primary key given by backing relational data store.
     */
    public Long getId() {
        return this.id;
    }

    /**
     * This method is not accessed by user code, just by Hibernate.
     */
    private void setId(Long id) {
        this.id = id;
    }

    
}
