/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS component_rel_type table.
 */
public class ComponentRelationshipType extends IRMISDataObject {

    private String relationshipType;

    /**
     * Do-nothing constructor.
     */
    public ComponentRelationshipType() {
    }

    /**
     * 
     */
    public String getRelationshipType() {
        return this.relationshipType;
    }
    /**
     * 
     */
    public void setRelationshipType(String value) {
        this.relationshipType = value;
    }

    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof ComponentRelationshipType) ) return false;
        final ComponentRelationshipType castOther = (ComponentRelationshipType) other;
        return this.getRelationshipType().equals(castOther.getRelationshipType());
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getRelationshipType());
        return result;
    }

}
