/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import gov.anl.aps.irmis.persistence.pv.URI;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS component_type_document table.
 */
public class ComponentTypeDocument extends IRMISDataObject {

    private URI uri;
    private ComponentType componentType;

    /**
     * Do-nothing constructor.
     */
    public ComponentTypeDocument() {
    }

    /**
     * 
     */
    public URI getUri() {
        return this.uri;
    }
    /**
     * 
     */
    public void setUri(URI value) {
        this.uri = value;
    }

    /**
     * 
     */
    public ComponentType getComponentType() {
        return this.componentType;
    }
    /**
     * 
     */
    public void setComponentType(ComponentType value) {
        this.componentType = value;
    }


    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof ComponentTypeDocument) ) return false;
        final ComponentTypeDocument castOther = (ComponentTypeDocument)other;
        return this.getComponentType().getComponentTypeName().equals(castOther.getComponentType().getComponentTypeName()) &&
            this.getUri().getUri().equals(castOther.getUri().getUri());
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getComponentType().getComponentTypeName());
        result = HashCodeUtil.hash(result, getUri().getUri());
        return result;
    }

}
