/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS component_type_if table.
 */
public class ComponentTypeInterface extends IRMISDataObject {

    private ComponentTypeInterfaceType interfaceType;
    private ComponentRelationshipType relationshipType;
    private ComponentType componentType;

    private boolean required;
    private boolean presented;

    /**
     * Do-nothing constructor.
     */
    public ComponentTypeInterface() {
    }

    /**
     * 
     */
    public ComponentTypeInterfaceType getInterfaceType() {
        return this.interfaceType;
    }
    /**
     * 
     */
    public void setInterfaceType(ComponentTypeInterfaceType value) {
        this.interfaceType = value;
    }

    /**
     * 
     */
    public ComponentRelationshipType getRelationshipType() {
        return this.relationshipType;
    }
    /**
     * 
     */
    public void setRelationshipType(ComponentRelationshipType value) {
        this.relationshipType = value;
    }

    /**
     * 
     */
    public ComponentType getComponentType() {
        return this.componentType;
    }
    /**
     * 
     */
    public void setComponentType(ComponentType value) {
        this.componentType = value;
    }

    /**
     * 
     */
    public boolean getRequired() {
        return this.required;
    }
    public void setRequired(boolean value) {
        this.required = value;
    }

    /**
     * 
     */
    public boolean getPresented() {
        return this.presented;
    }
    public void setPresented(boolean value) {
        this.presented = value;
    }


    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof ComponentTypeInterface) ) return false;
        final ComponentTypeInterface castOther = (ComponentTypeInterface)other;
        return this.getId() == castOther.getId();
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getId());
        return result;
    }

}
