/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS component_type_if_type table.
 */
public class ComponentTypeInterfaceType extends IRMISDataObject {

    private String interfaceType;

    /**
     * Do-nothing constructor.
     */
    public ComponentTypeInterfaceType() {
    }

    /**
     * 
     */
    public String getInterfaceType() {
        return this.interfaceType;
    }
    /**
     * 
     */
    public void setInterfaceType(String value) {
        this.interfaceType = value;
    }

    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof ComponentTypeInterfaceType) ) return false;
        final ComponentTypeInterfaceType castOther = (ComponentTypeInterfaceType) other;
        return this.getInterfaceType().equals(castOther.getInterfaceType());
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getInterfaceType());
        return result;
    }

}
