/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS port_pin_designator table.
 */
public class PortPinDesignator extends IRMISDataObject {

    private ComponentPortType componentPortType;
    private String designator;
    private int designatorOrder;

    /**
     * Do-nothing constructor.
     */
    public PortPinDesignator() {
    }


    /**
     *
     */
    public ComponentPortType getComponentPortType() {
        return this.componentPortType;
    }
    /**
     *
     */
    public void setComponentPortType(ComponentPortType value) {
        this.componentPortType = value;
    }

    /**
     * 
     */
    public String getDesignator() {
        return this.designator;
    }
    /**
     * 
     */
    public void setDesignator(String value) {
        this.designator = value;
    }

    /**
     *
     */
    public int getDesignatorOrder() {
        return this.designatorOrder;
    }
    /**
     *
     */
    public void setDesignatorOrder(int value) {
        this.designatorOrder = value;
    }
 

    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof PortPinDesignator) ) return false;
        final PortPinDesignator castOther = (PortPinDesignator) other;
        return this.getComponentPortType().getId() ==  castOther.getComponentPortType().getId() &&
            this.getDesignatorOrder() == castOther.getDesignatorOrder();
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getComponentPortType().getId());
        result = HashCodeUtil.hash(result, getDesignatorOrder());
        return result;
    }

}
