/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS port_pin_template table.
 */
public class PortPinTemplate extends IRMISDataObject {

    private ComponentPortTemplate componentPortTemplate;
    private PortPinType portPinType;
    private PortPinDesignator portPinDesignator;

    private String portPinName;
    private String portPinIoAddr;
    private Date modifiedDate;
    private String modifiedBy;

    /**
     * Do-nothing constructor.
     */
    public PortPinTemplate() {
    }


    /**
     *
     */
    public ComponentPortTemplate getComponentPortTemplate() {
        return this.componentPortTemplate;
    }
    /**
     *
     */
    public void setComponentPortTemplate(ComponentPortTemplate value) {
        this.componentPortTemplate = value;
    }

    /**
     *
     */
    public PortPinType getPortPinType() {
        return this.portPinType;
    }
    /**
     *
     */
    public void setPortPinType(PortPinType value) {
        this.portPinType = value;
    }

    /**
     *
     */
    public PortPinDesignator getPortPinDesignator() {
        return this.portPinDesignator;
    }
    /**
     *
     */
    public void setPortPinDesignator(PortPinDesignator value) {
        this.portPinDesignator = value;
    }

    /**
     * 
     */
    public String getPortPinName() {
        return this.portPinName;
    }
    /**
     * 
     */
    public void setPortPinName(String value) {
        this.portPinName = value;
    }

    /**
     * 
     */
    public String getPortPinIoAddr() {
        return this.portPinIoAddr;
    }
    /**
     * 
     */
    public void setPortPinIoAddr(String value) {
        this.portPinIoAddr = value;
    }

    /**
     * Direct reflection of last modification of underlying database row.
     */
    public Date getModifiedDate() {
        return this.modifiedDate;
    }
    public void setModifiedDate(Date value) {
        this.modifiedDate = value;
    }

    /**
     * Represent user name or application name which last modified (created)
     * underlying database row.
     */
    public String getModifiedBy() {
        return this.modifiedBy;
    }
    public void setModifiedBy(String value) {
        this.modifiedBy = value;
    }
 

    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof PortPinTemplate) ) return false;
        final PortPinTemplate castOther = (PortPinTemplate) other;
        return this.getComponentPortTemplate().getId()==
            castOther.getComponentPortTemplate().getId() &&
            this.getPortPinType().getId()==
            castOther.getPortPinType().getId() &&
            this.getPortPinDesignator().getId()==
            castOther.getPortPinDesignator().getId();
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getComponentPortTemplate().getId());
        result = HashCodeUtil.hash(result, getPortPinType().getId());
        result = HashCodeUtil.hash(result, getPortPinDesignator().getId());
        return result;
    }

}
