/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.component;

import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.HashCodeUtil;

import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 * IRMIS business object that represents 
 * This class is mapped via hibernate one-to-one with IRMIS port_pin_type table.
 */
public class PortPinType extends IRMISDataObject {

    private String portPinType;

    /**
     * Do-nothing constructor.
     */
    public PortPinType() {
    }

    /**
     * 
     */
    public String getPortPinType() {
        return this.portPinType;
    }
    /**
     * 
     */
    public void setPortPinType(String value) {
        this.portPinType = value;
    }

    public String toString() {
        return getId().toString();
    }

    /**
     * Custom equals which compares "business key" equality.
     */
    public boolean equals(Object other) {
        if (this==other) return true;
        if ( !(other instanceof PortPinType) ) return false;
        final PortPinType castOther = (PortPinType) other;
        return this.getPortPinType().equals(castOther.getPortPinType());
    }

    /**
     * Custom hashCode computed on "business key" fields.
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, getPortPinType());
        return result;
    }

}
