/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.service;

// persistence layer
import gov.anl.aps.irmis.persistence.IRMISDataObject;
import gov.anl.aps.irmis.persistence.DAOException;
import gov.anl.aps.irmis.persistence.pv.RecordDAO;

import java.util.List;

public abstract class IRMISService {

    public void clearCache(IRMISDataObject irmisDataObject) throws IRMISException {

        // doesn't matter which DAO we use here
        RecordDAO rDAO = null;
        try {
            // Clear the hibernate first-level cache of previously retrieved objects.
            rDAO = new RecordDAO();
            rDAO.evict(irmisDataObject);
        } catch (DAOException de) {
            throw new IRMISException(de);
        }
    }

    public void clearCache(List irmisDataObjects) throws IRMISException {

        // doesn't matter which DAO we use here
        RecordDAO rDAO = null;
        try {
            // Clear the hibernate first-level cache of previously retrieved objects.
            rDAO = new RecordDAO();
            rDAO.evict(irmisDataObjects);
        } catch (DAOException de) {
            throw new IRMISException(de);
        }
    }

}
