/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.service.component;

// java imports
import java.util.List;
import java.util.Iterator;
import java.util.Set;
import java.util.SortedSet;

// IRMIS persistence layer
import gov.anl.aps.irmis.persistence.component.ComponentType;
import gov.anl.aps.irmis.persistence.component.ComponentTypeDAO;
import gov.anl.aps.irmis.persistence.DAOException;

// IRMIS service layer
import gov.anl.aps.irmis.service.IRMISService;
import gov.anl.aps.irmis.service.IRMISException;

/**
 * Component Service providing a variety of methods to acquire and
 * manipulate the component and component type object graphs.
 */
public class ComponentService extends IRMISService {

    /**
     * Do-nothing constructor.
     */
    public ComponentService() {
    }

    public List findComponentTypeList() throws IRMISException {
        ComponentTypeDAO ctDAO = null;
        List ctList = null;
        try {
            ctDAO = new ComponentTypeDAO();
            ctList = ctDAO.findAllComponentTypes();
        } catch (DAOException de) {
            throw new IRMISException(de);
        }        
        return ctList;
    }

    public void saveComponentType(ComponentType compType) throws IRMISException {
        ComponentTypeDAO ctDAO = null;
        try {
            ctDAO = new ComponentTypeDAO();
            ctDAO.save(compType);
        } catch (DAOException de) {
            throw new IRMISException(de);
        }        
    }

}
